'use strict';

var asCallback = require('ascallback');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var asCallback__default = /*#__PURE__*/_interopDefaultLegacy(asCallback);

const defaultHandleError = (val) => Promise.reject(val);

var index = ({ handleError = defaultHandleError } = {}) => (socket, next) => {
  const on = socket.on.bind(socket);
  socket.on = (event, handler, ...args) => { // eslint-disable-line no-param-reassign
    const newHandler = (...handlerArgs) => {
      const cb = handlerArgs.pop();
      const res = handler(...handlerArgs)?.catch?.((err) => handleError(err, event));

      if (typeof res?.then === 'function') {
        asCallback__default["default"](res, cb);
      }
    };

    on(event, newHandler, ...args);
  };

  next();
};

module.exports = index;
//# sourceMappingURL=index.cjs.map
